Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.i2p.crypto
Class ElGamalEngine

    java.lang.Object
      net.i2p.crypto.ElGamalEngine

Direct Known Subclasses:
  DummyElGamalEngine

    public class ElGamalEngine

extends Object

Wrapper for ElGamal encryption/signature schemes. Does all of Elgamal now for data sizes of 222 bytes and less. The data to be encrypted is first prepended with a random nonzero byte, then the 32 bytes making up the SHA256 of the data, then the data itself. The random byte and the SHA256 hash is stripped on decrypt so the original data is returned.

Author:
  thecrypto, jrandom

Constructor Summary
`ElGamalEngine(I2PAppContext context)` The ElGamal engine should only be constructed and accessed through the application context.

Method Summary
`byte[]` | `decrypt(byte[] encrypted, PrivateKey privateKey)` Decrypt the data
`byte[]` | `encrypt(byte[] data, PublicKey publicKey)` encrypt the data to the public key
`static void` | `main(String[] args)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### ElGamalEngine

    public ElGamalEngine(I2PAppContext context)

  The ElGamal engine should only be constructed and accessed through the application context. This constructor should only be used by the appropriate application context itself.

Method Detail

### encrypt

    public byte[] encrypt(byte[] data,
                          PublicKey publicKey)

  encrypt the data to the public key

  Parameters:
    `publicKey` - public key encrypt to
    `data` - data to encrypt, must be 222 bytes or less As the encrypted data may contain a substantial number of zeros if the cleartext is smaller than 222 bytes, it is recommended that the caller pad the cleartext to 222 bytes with random data.
  Returns:
    encrypted data, will be exactly 514 bytes long Contains the two-part encrypted data starting at bytes 0 and 257. If the encrypted parts are smaller than 257 bytes, they will be padded with leading zeros. The parts appear to always be 256 bytes or less, in other words, bytes 0 and 257 are always zero.

### decrypt

    public byte[] decrypt(byte[] encrypted,
                          PrivateKey privateKey)

  Decrypt the data

  Parameters:
    `encrypted` - encrypted data, must be exactly 514 bytes Contains the two-part encrypted data starting at bytes 0 and 257. If the encrypted parts are smaller than 257 bytes, they must be padded with leading zeros.
    `privateKey` - private key to decrypt with
  Returns:
    unencrypted data or null on failure

### main

    public static void main(String[] args)

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD